<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button (click)="newRow(); openModal(modal, 'Modificadores')" class="btn btn-primary">
    <i class="fas fa-plus mr-2"></i>Nuevo
  </button>
  <button (click)="printPDF()" class="btn btn-danger ml-1" [disabled]="!dataGrid.data || loading">
    <i class="fas fa-file-pdf mr-2"></i>PDF
  </button>
</app-page-title>

<div class="card">
  <div class="card-body">

    <kendo-grid [kendoGridBinding]="dataGrid.data" [filter]="filter" [filterable]="true" [selectable]="true"
      [navigable]="true" [reorderable]="true" [resizable]="true" [sort]="sort" [sortable]="true" [groupable]="false"
      [group]="groups" (edit)="editRow($event); openModal(modal, 'Modificadores')" (remove)="deleteRow($event)"
      style="height: 75vh" [skip]="0" [pageSize]="10"
      [pageable]="{buttonCount: 5, pageSizes: [10, 25, 50]}" *ngIf="!loading">
      <ng-template kendoGridToolbarTemplate>
        <button type="button" kendoGridExcelCommand icon="file-excel" [disabled]="dataGrid.data.length === 0"
         class="btn-success">Exportar Excel</button>
      </ng-template>
      <kendo-grid-column field="Modificador" title="Modificador" width="250"></kendo-grid-column>
      <kendo-grid-column field="Descripcion" title="Descripción"></kendo-grid-column>
      <kendo-grid-column field="Inactivo" title="Inactivo" width="120">
        <ng-template kendoGridFilterCellTemplate>
          <kendo-switch (valueChange)="switchChange($event)" offLabel="No" [checked]="checked" onLabel="Si">
          </kendo-switch>
        </ng-template>
        <ng-template kendoGridCellTemplate let-dataItem>
          <input type="checkbox" [checked]="dataItem.Inactivo" disabled />
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-command-column title="Actions" width="190">
        <ng-template kendoGridCellTemplate let-isNew="isNew">
          <button kendoGridEditCommand [primary]="true">Editar</button>
          <button kendoGridRemoveCommand>Eliminar</button>
        </ng-template>
      </kendo-grid-command-column>
      <kendo-grid-excel fileName="{{this.heading}}.xlsx" [fetchData]="allData"></kendo-grid-excel>
    </kendo-grid>

    <app-loading *ngIf="loading"></app-loading>

  </div>
</div>

<ng-template #modal let-modal let-c="close">
  <div class="modal-header">
    <h6 class="modal-title" id="modal-graf">{{ modalTitle }}</h6>
    <button class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <div class="row" *ngIf="flagShowForm">
      <form [formGroup]="myFormGroup" class="k-form">
          <legend *ngIf="!flagEdit">Nuevo Modificador</legend>
          <legend *ngIf="flagEdit">Actualizar Modificador</legend>
          <label class="k-form-field">
            <span>Modificador</span>
            <input class="k-textbox" name="Modificador" [(ngModel)]="myFormGroup.value.Modificador"
              formControlName="Modificador" [readOnly]="flagEdit" maxlength="10"/>
          </label>
          <label class="k-form-field">
            <span>Descripción</span>
            <input class="k-textbox" name="Descripcion" [(ngModel)]="myFormGroup.value.Descripcion"
              formControlName="Descripcion" maxlength="40">
          </label>
          <label class="k-form-field">
            <span>Inactivo</span>
            <kendo-switch class="" name="Inactivo" [(ngModel)]="myFormGroup.value.Inactivo" formControlName="Inactivo"
              [onLabel]="'Si'" [offLabel]="'No'">
            </kendo-switch>
          </label>
      </form>
    </div>
  </div>
  <div class="modal-footer">
      <button class="btn btn-success" (click)="guardarForm(); c();"
      [disabled]="myFormGroup.status === 'INVALID'">
        <i class="fas fa-save mr-2"></i>Guardar
      </button>
      <button class="btn btn-secondary" (click)="closeForm(); c('Close click')">Cerrar</button>
  </div>
</ng-template>
